// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#ifndef CLB_H
#define CLB_H

#include "vprArch.h"
class logicBlock;

class c_clb{
 public:
  string name;
  vector<logicBlock *> lutVector;
  vector<logicBlock *> registerVector;

  int row;
  int col;

  c_clb(string n){
    name = n;
    row = -1;
    col = -1;
  }

  void updateLocation(registerBank *block){
    row = block->getHostCLB()->get_row();
    col = block->getHostCLB()->get_col();
  }
  void updateLocation(vprLUT *block){
    row = block->get_row();
    col = block->get_col();
  }
  void clearLocation(registerBank *block){
    if(row != block->getHostCLB()->get_row()){
      ERROR("Mismatch in clb location!");
    }
    else if(col !=  block->getHostCLB()->get_col()){
      ERROR("Mismatch in clb location!");
    }
    row = -1;
    col = -1;
  }
  void clearLocation(vprLUT *block){
    if(row != block->get_row()){
      ERROR("Mismatch in clb location!");
    }
    else if(col !=  block->get_col()){
      ERROR("Mismatch in clb location!");
    }
    row = block->get_row();
    col = block->get_col();
  }

  void unPlaceLogicBlocksFromLUTsAndFF(registerBank *block);
  void unPlaceLogicBlocksFromLUTsAndFF(vprLUT *block);
  void unPlaceLogicBlocksFromLUTs(vprLUT *block);

  void placeLogicBlocksToLUTsAndFF(registerBank *block);
  void placeLogicBlocksToLUTsAndFF(vprLUT *block);
  void placeLogicBlocksToLUTs(vprLUT *block);

  void updateSinkDelaysAndSlacksForLUTsAndFF();
  void updateSinkDelaysAndSlacksForLUTs();

  void updateCostsAndDeltasForLUTsAndFF(bool timing_driven, double criticalPathDelay, double *deltaWire, double *deltaTiming);
  void updateCostsAndDeltasForLUTsAndFFCostDeltaDelay(bool timing_driven, double criticalPathDelay, double *deltaWire, double *deltaTiming, double *deltaTimingPrime);
  void updateCostsAndDeltasForLUTs(bool timing_driven, double criticalPathDelay, double *deltaWire, double *deltaTiming);
  void updateCostsAndDeltasForLUTsCostDeltaDelay(bool timing_driven, double criticalPathDelay, double *deltaWire, double *deltaTiming, double *deltaTimingPrime);
};

#endif
