/* Copyright (C) 2008 Ken Eguro & Scott Hauck */
/* You can contact the authors electronically at eguro at ee dot washington dot edu */
/* or by regular mail at  */
/* Box 352500,  */
/* University of Washington */
/* Seattle, WA 98195 */


%{
#include <strings.h>
#include <iostream>
#include "mcncParser.tab.h"
%}

%%
"("                     {}
")"                     {}
","                     {}
([0-9]+\.[0-9]+)([eE][-+]?[0-9]+)?  {yylval.double_num=atof(yytext); return DOUBLENUM_TOK; }

"."                     {yylval.word=strdup(yytext); return PERIOD_TOK; }
" to "                  {yylval.word=strdup(yytext); return TO_TOK; }
"Node:"                 {yylval.word=strdup(yytext); return NODE_TOK; }
"Block Name:"           {yylval.word=strdup(yytext); return BLOCKNAME_TOK; }
"Block Type:"           {yylval.word=strdup(yytext); return BLOCKTYPE_TOK; }
"Wire Name:"            {yylval.word=strdup(yytext); return WIRENAME_TOK; }
"CHANY"                 {yylval.word=strdup(yytext); return CHANY_TOK; }
"CHANX"                 {yylval.word=strdup(yytext); return CHANX_TOK; }
"SOURCE"                {yylval.word=strdup(yytext); return SOURCE_TOK; }
"SINK"                  {yylval.word=strdup(yytext); return SINK_TOK; }
"IPIN"                  {yylval.word=strdup(yytext); return IPIN_TOK; }
"OPIN"                  {yylval.word=strdup(yytext); return OPIN_TOK; }
"REGISTER"                 {yylval.word=strdup(yytext); return REGISTER_TOK; }
"Ptc_num:"              {yylval.word=strdup(yytext); return PTC_TOK; }
"edge(s):"              {yylval.word=strdup(yytext); return EDGES_TOK; }
"Switch types:"         {yylval.word=strdup(yytext); return SWITCHTYPE_TOK; }
"Occ:"                  {yylval.word=strdup(yytext); return OCC_TOK; }
"Capacity:"             {yylval.word=strdup(yytext); return CAPACITY_TOK; }
"R:"                    {yylval.word=strdup(yytext); return R_TOK; }
"C:"                    {yylval.word=strdup(yytext); return C_TOK; }
"Cost_index:"           {yylval.word=strdup(yytext); return COSTINDEX_TOK; }
"Intrinsic Delay:"      {yylval.word=strdup(yytext); return INTRINSICDELAY_TOK; }


"Netlist file:"        {yylval.word=strdup(yytext); return NETLISTFILE_TOK; }
"Architecture file:"           {yylval.word=strdup(yytext); return ARCHFILE_TOK; }
"PLACEMENT: " {yylval.word=strdup(yytext); return PLACEMENTFILE_TOK; }

".input"                { /* printf("found input...%s\n",yytext); */
                          yylval.word=strdup(yytext); return INPUT_TOK; }
".output"               { /* printf("found output...%s\n",yytext); */
                          yylval.word=strdup(yytext); return OUTPUT_TOK; }
".clb"                  { /* printf("found clb...%s\n",yytext); */
                          yylval.word=strdup(yytext); return CLB_TOK; }
".type"                 { /* printf("found clb...%s\n",yytext); */
                          yylval.word=strdup(yytext); return TYPE_TOK; }
"pinlist:"              { /* printf("found pinlist...%s\n",yytext); */
                          yylval.word=strdup(yytext); return PINLIST_TOK; }
".subblock"             { /* printf("found subblock...%s\n",yytext); */
                          yylval.word=strdup(yytext); return SUBBLOCK_TOK; }
".subblockREG"          { /* printf("found subblock...%s\n",yytext); */
                          yylval.word=strdup(yytext); return SUBBLOCKREG_TOK; }
"delay:"                { /* printf("found delay...%s\n",yytext); */
                          yylval.word=strdup(yytext); return DELAY_TOK; }
".global"               { /* printf("found global decln...%s\n",yytext); */
                          yylval.word=strdup(yytext); return GLOBAL_TOK; }
#.*                     { /* printf("found comment...%s\n",yytext); */
                          yylval.word=strdup(yytext); return ANNOTATION_TOK; }
[\[\]a-zA-Z0-9_:<>]+ { /* printf("found net...%s\n",yytext); */
                          yylval.word=strdup(yytext); return NET_TOK; }
[\t\n ]+                { /* printf("found whitespace...%s\n",yytext); */}
"\\"                    {}
%%

void yyerror(char* str){
  fprintf(stderr,"%s AND ERRONEOUS TOKEN IS %s\n",str, yytext);
  exit(-1);
}

/*[a-zA-Z0-9_:<>]+       { /* printf("found net...%s\n",yytext);*/
/*                          yylval.word=strdup(yytext); return NET_TOK; }*/
/*("AR_")([\[\]a-zA-A0-9_:<>]+) {yylval.word=strdup(yytext); return PLACEMENTFILE_TOK; }*/

