// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#include "include.h"

// Set name of net
void mcncNet::set_name(char* n){
  if(magicNum!=13111)
    ERROR("trying to access a deleted node...");
  name = n;
}

// Add a block to sinkList
void mcncNet::addto_sinkList(mcncBlock* p_block){
  if(!p_block)
    ERROR("cannot add NULL sink...");
  if(magicNum!=13111)
    ERROR("trying to access a deleted node...");
  sinkList.push_back(p_block);
  numSinks++;
}

// Set source of net
void mcncNet::set_source(mcncBlock* p_block){
  if(!p_block)
    ERROR("source cannot be NULL...");
  if(magicNum!=13111)
    ERROR("trying to access a deleted node...");
  source=p_block;
}

// Get name of net
string mcncNet::get_name(){
  if(magicNum!=13111)
    ERROR("trying to access a deleted node...");
  return name;
}

// Get source of net
mcncBlock* mcncNet::get_source(){
  if(magicNum!=13111)
    ERROR("trying to access a deleted node...");
  return source;
}

// Get num of sink clbs
int mcncNet::get_numSinks(){
  if(magicNum!=13111)
    ERROR("trying to access a deleted node...");
  return sinkList.size();
}

// Print info about this net. This includes name of net, source and sink blocks
void mcncNet::print_NetInfo(){
  if(magicNum!=13111)
    ERROR("trying to access a deleted node...");

  cout<<endl<<endl<<"BEGIN PRINT INFO FOR NET "<<name;

  //print source
  cout<<endl<<"SOURCE: "<<source->get_name();

  //print sinks
  cout<<endl<<"SINK LIST -->";
  list<mcncBlock *>::iterator sink_list_itr = sinkList.begin();
  for(;sink_list_itr!=sinkList.end();sink_list_itr++)
    cout<<endl<<"\t"<<(*sink_list_itr)->get_name();

}


