// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#include "include.h"


// This function converts the mcnc netlist to a generic netlist. This is the
// step that converts benchmark netlists of a particular format to a representation 
// that the Independence algorithm routines will recognize and
// operate upon.
Netlist* convert2GenericNetlist(mcncNetlist *mcnc_netlist){
  Netlist *netlist = new Netlist;
  mcnc_netlist->convert2Generic(netlist);

  delete mcnc_netlist;
  return netlist;
}

// Create a vpr challenge FPGA object.
vprFPGA* create_vprFPGA(Netlist* netlist, int num_clb_rows,int num_clb_cols,int num_ios){
  vprFPGA *FPGA;

  // Check whether target arrays is big enough
  if(netlist->get_numCLBs() > num_clb_rows * num_clb_cols){
    cout << "WARNING!  Target array may not be big enough - you may need to increase num clb rows & cols"<< endl;
    //ERROR("Target array is not big enough. Need to increase num clb rows/cols.");
  }
  if(netlist->get_numInputs() + netlist->get_numOutputs() > num_ios * 2 * (num_clb_rows + num_clb_cols))
    ERROR("Target array is not big enough. Need to increase num iobs per clb row/col.");

  FPGA = new vprFPGA(num_clb_rows, num_clb_cols,num_ios);

  return FPGA;
}
