// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

class vprFPGA;
class Netlist;

void place(Netlist *netlist, bool pipeline_aware, bool timing_driven, FILE* fp);
void ltAnneal(Netlist *netlist, bool pipeline_aware, bool timing_driven);
void independencePlacement(Netlist *netlist, bool timing_driven, FILE* fp);

void initPlacement(Netlist *netlist);

float calcStartTemperature(Netlist *netlist, bool timing_driven);
void generateMove(Netlist *netlist, void** block0,int* index0,void** block1,int* index1,int* block_type, float dLimit);
bool movable_block(logicBlock* lb);

void makeMove(void** block0,int* index0,void** block1,int* index1,int* block_type,int iter, bool timing_driven);
void undoMove(void** block0,int* index0,void** block1,int* index1,int* block_type,list<cachedObj*>* src_list0,
              list<cachedObj*>* src_list1,list<cachedObj*>* sink_list0,
              list<cachedObj*>* sink_list1,int iter, bool timing_driven);
void placeBlock(logicBlock* lb,void* b, enum e_timingMoveBlockType t,int index);
void unPlaceBlock(logicBlock* lb,void* b, enum e_timingMoveBlockType t,int index);
void ripRoutes(logicBlock* lb0,logicBlock* lb1);

void annealDesign(Netlist *netlist, FILE* fp, bool timing_driven, float annealTemp);
void cacheRoutes(void** block0,int* index0,void** block1,int* index1,int* block_type,list<cachedObj*>* src_list0,
                 list<cachedObj*>* src_list1,list<cachedObj*>* sink_list0,
                 list<cachedObj*>* sink_list1);
void sortSinks(void** block0,int* index0,void** block1,int* index1,int* block_type);
void clearCachedRoutes(list<cachedObj*>* src_list0,list<cachedObj*>* src_list1,
		       list<cachedObj*>* sink_list0,list<cachedObj*>* sink_list1,int clear_tree);

int calcWireCost(Netlist *netlist);
void printNetsAndRecalcCosts(Netlist *netlist);

//void placeIO(Netlist *netlist);

void printPlacement(Netlist *netlist);
void printVPRPlacement(Netlist *netlist, long int random_seed, char* rr_echo, char* arguments, FILE* out_fp);

void swapBlocks(void** block0, int* index0, void** block1, int* index1, int* block_type);

void findCostAndCPofPlacement(Netlist *netlist);
