// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#ifndef REPLACEMENTROUTE_H
#define REPLACEMENTROUTE_H

class PipeliningNet;
class routeTree;
class Terminal;

class ReplacementRoute{
 public:
  double pathCost;
  list<PipeliningNet*> ripUpNetList;
  list<routeTree*> ripUpRouteList;

  PipeliningNet* addToNet;
  routeTree addToRoute;
  Terminal* sink;
  double pathDelay;
  int targetLatency;

  ReplacementRoute(){
    pathCost = DBL_MAX;
  }

  ~ReplacementRoute(){
    for(list<routeTree*>::iterator ripIter = ripUpRouteList.begin();  ripIter != ripUpRouteList.end(); ripIter++){
      delete (*ripIter);
    }
  }
};

#endif
