// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#include "include.h"

// Set type of routing edge i.e. buffered or unbuffered
void routingEdge::set_type(enum e_routingEdgeType t){  
  if(magicNum!=20111)
    ERROR("trying to access a deleted node...");
  type=t;
}

// Set the routing node that originates this edge
void routingEdge::set_origNode(routingNode* n){
  if(magicNum!=20111)
    ERROR("trying to access a deleted node...");
  if(n==0)
    ERROR("NULL originating routing node...");
  origNode=n;
}

// Set the routing node that sinks this edge
void routingEdge::set_destNode(routingNode* n){
  if(magicNum!=20111)
    ERROR("trying to access a deleted node...");
  if(n==0)
    ERROR("NULL sink routing node...");
  destNode=n;
}

// // Set the resistance of this edge
// void routingEdge::set_R(double r){
//   if(magicNum!=20111)
//     ERROR("trying to access a deleted node...");
//   if(r<0.)
//     ERROR("resistance cannot be -ve...");
//   R=r;
// }

// // Set the input capacitance of this edge
// void routingEdge::set_Cin(double c){
//   if(magicNum!=20111)
//     ERROR("trying to access a deleted node...");
//   if(c<0.)
//     ERROR("capacitance cannot be -ve...");
//   Cin=c;
// }

// // Set the output capacitance of this edge
// void routingEdge::set_Cout(double c){
//   if(magicNum!=20111)
//     ERROR("trying to access a deleted node...");
//   if(c<0.)
//     ERROR("capacitance cannot be -ve...");
//   Cout=c;
// }

// Set the intrinsice delay of this edge
void routingEdge::set_intrinsicDelay(double d){
  if(magicNum!=20111)
    ERROR("trying to access a deleted node...");
  if(d<0.)
    ERROR("intrinsic delay cannot be -ve...");
  intrinsicDelay=d;
}

// Get type of this routing edge
enum e_routingEdgeType routingEdge::get_type(){
 if(magicNum!=20111)
   ERROR("trying to access a deleted node...");
 return type;
}

// Get the routing node that originates this edge
routingNode* routingEdge::get_origNode(){
  if(magicNum!=20111)
    ERROR("trying to access a deleted node...");
  return origNode;
}

// Get the routing node that sinks this edge
routingNode* routingEdge::get_destNode(){
  if(magicNum!=20111)
    ERROR("trying to access a deleted node...");
  return destNode;
}

// // Get the resistance of this edge
// double routingEdge::get_R(){
//   if(magicNum!=20111)
//     ERROR("trying to access a deleted node...");
//   return R;
// }

// // Get the input capacitance of this edge
// double routingEdge::get_Cin(){
//   if(magicNum!=20111)
//     ERROR("trying to access a deleted node...");
//   return Cin;
// }

// // Get the output capacitance of this edge
// double routingEdge::get_Cout(){
//   if(magicNum!=20111)
//     ERROR("trying to access a deleted node...");
//   return Cout;
// }

// // Get the intrinsic delay of this edge
// double routingEdge::get_intrinsicDelay(){
//   if(magicNum!=20111)
//     ERROR("trying to access a deleted node...");
//   return intrinsicDelay;
// }

// Print this routing edge's info
void routingEdge::print_info(){
  if(magicNum!=20111)
    ERROR("trying to access a deleted node...");

  cout<<destNode->get_name();

//    cout<<endl<<"\t\tPRINT ROUTING EDGE";
//    cout<<endl<<"\t\tORIG IS "<<origNode->get_name()<<" AND DEST IS "<<destNode->get_name();
//    cout<<endl<<"\t\tR = "<<R<<", Cin = "<<Cin<<", Cout = "<<Cout<<", DELAY = "
//        <<intrinsicDelay;
}

