// Copyright (C) 2008 Ken Eguro & Scott Hauck
// You can contact the authors electronically at eguro at ee dot washington dot edu
// or by regular mail at 
// Box 352500, 
// University of Washington
// Seattle, WA 98195

#include "include.h"
extern unsigned int *VECTORMASK;

// Give this routing node a name
void routingNode::set_name(char* n){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(n==0)
    ERROR("name of routing node cannot be NULL...");
  name = n;
}

void routingNode::set_blockName(char* n){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(n==0)
    ERROR("name of block cannot be NULL...");
  blockName = n;
}

// void routingNode::set_blockType(enum e_routingNodeType t){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   if(t<0 || t > 5)
//     ERROR("Unknown block type");
//   blockType = t;
// }

//void routingNode::set_wireName(char* n){
//  if(magicNum!=19111)
//    ERROR("trying to access a deleted node...");
//  if(n==0)
//    ERROR("name of block cannot be NULL...");
//  wireName = n;
//}

// enum e_genericBlockType routingNode::get_blockType(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   return (blockType);
// }

// Add a terminal that is mapped to this node
// void routingNode::addto_terminalList(Terminal* t){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   if(t==0)
//     ERROR("trying to map NULL terminal to this routing node...");
//   terminalList.push_back(t);

// }

// Create a new iterator for terminalList
// void routingNode::create_terminalListItr(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   if(terminal_itr)
//     ERROR("terminal iterator already exists...");
//   terminal_itr=new list<Terminal*>::iterator;
//   *terminal_itr = terminalList.begin();
// }

// Remove an already existing terminalList iterator 
// void routingNode::remove_terminalListItr(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   if(terminal_itr==0)
//     ERROR("trying to delete NULL terminal iterator...");
//   delete terminal_itr;
//   terminal_itr=0;
// }

// Get next element from terminalList
// Terminal* routingNode::getnext_terminalList(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");

//   if(*terminal_itr == terminalList.end())
//     return 0;
//   else{
//     Terminal* ret_ptr = **terminal_itr;
//     (*terminal_itr)++;
//     return ret_ptr;
//   }

// }

// Set type of routing node
void routingNode::set_type(e_routingNodeType t){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  type=t;
}

// Set this node's wavefront predecessor
void routingNode::set_predecessor(routingNode* pr){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  predecessor=pr;
}

// Set resistance of wire routing node
void routingNode::set_R(double r){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(r<0.)
    ERROR("resistance cannot be -ve...");
  R=r;
}

// Set input cap of wire routing node
void routingNode::set_Cin(double c){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(c<0.)
    ERROR("capacitance cannot be -ve...");
  Cin=c;
}

// Set output cap of wire routing node
void routingNode::set_Cout(double c){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(c<0.)
    ERROR("capacitance cannot be -ve...");
  Cout=c;
}

// Set base cost of this routing node
void routingNode::set_baseCost(double b){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(b<0.)
    ERROR("base cost cannot be set -ve...");
  baseCost=b;
}

// Update history cost of this routing node.
// This function will be called after every placement iteration
// void routingNode::update_historyCost(int iter, bool during_placement){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");

//   if(iter==1)
//     historyCost = 1.0;
//   else{
//     if(during_placement){
//       if(occupancy > capacity)
// 	historyCost = doubmax(1.0, 0.9*historyCost + 0.5);
//       else
// 	historyCost = doubmax(1.0, 0.9*historyCost);
//     }
//     else{
//       historyCost = historyCost + doubmax(0.0,(double)(occupancy - capacity));
//     }
//   }
// }

// Update the tuning parameter for presentSharing...VPR router
// This function will be called after every placement iteration
void routingNode::update_pfac(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  pfac*=1.25;
}

// Set the occupancy of this routing node
void routingNode::set_occupancy(int occ){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(occ<0)
    ERROR("occupancy of routing node cannot be < 0...");
  //Sources and sinks are no longer special since we can do routing through a cell.
  //if(type==SOURCE || type==SINK){
  //  if(occ>capacity){
  //    cout<<endl<<endl<<"VIOLATED TERMINAL IS "<<name<<" AT OCC = "<<occ;
  //    ERROR("occupancy of source/sink routing node cannot exceed capacity...");
  //  }
  //}
  occupancy=occ;
}

// Set the capacity of this routing node
void routingNode::set_capacity(int c){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(c<0)
    ERROR("capacity of routing node cannot be < 0...");
  capacity=c;
}

// Whether this node has been explored by a wavefront
void routingNode::set_isExplored(bool e){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(e!=true && e!=false)
    ERROR("non-bool value here...");
  isExplored=e;
}

// Set the current path cost of this routing node
void routingNode::set_pathCost(double p){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(p<0.)
    ERROR("path cost cannot be -ve...");
  pathCost=p;
}

// Add a routing edge to the fanin list   
void routingNode::addto_faninList(routingEdge* e){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(e==0)
    ERROR("adding NULL routing edge here...");
  faninList.push_back(e);
}

// Add a routing edge to the fanout list   
void routingNode::addto_fanoutList(routingEdge* e){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(e==0)
    ERROR("adding NULL routing edge here...");
  fanoutList.push_back(e);
}

// Create a new iterator for faninList
void routingNode::create_faninListItr(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(fanin_itr)
    ERROR("fanin iterator already exists...");
  fanin_itr=new list<routingEdge*>::iterator;
  *fanin_itr = faninList.begin();
}

// Remove an already existing faninList iterator 
void routingNode::remove_faninListItr(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  if(fanin_itr==0)
    ERROR("trying to delete NULL fanin iterator...");
  delete fanin_itr;
  fanin_itr=0;
}

// // Create a new iterator for fanoutList
// void routingNode::create_fanoutListItr(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   if(fanout_itr)
//     ERROR("fanout iterator already exists...");
//   fanout_itr=new list<routingEdge*>::iterator;
//   *fanout_itr = fanoutList.begin();
// }

// // Remove an already existing fanoutList iterator 
// void routingNode::remove_fanoutListItr(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   if(fanout_itr==0)
//     ERROR("trying to delete NULL fanout iterator...");
//   delete fanout_itr;
//   fanout_itr=0;
// }

// Whether this routing node is in the current route tree of the net being routed 
void routingNode::set_inrTree(bool r){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  inrTree=r;
}

// // Return true if this routing node is in the route tree of the net being routed
// bool routingNode::get_inrTree(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   return inrTree;
// }

// Applicable only to sink routing nodes. If a sink
// terminal of net is mapped to this routing node return true
// bool routingNode::foundTerminal(Net* net){
//   if(magicNum!=19111)
//     ERROR("trying to access deleted node...");

//   create_terminalListItr();
//   for(Terminal* term=getnext_terminalList();term!=0;term=getnext_terminalList()){
//     if(term->get_net()==net){
//       remove_terminalListItr();
//       return true;
//     }
//   }
//   remove_terminalListItr();
//   return false;

// }

// // Get the current cost of this routing node
// double routingNode::returnCongestionCost(int iter,bool pathfinder_pshare, bool timing_driven){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");

//   //if(get_baseCost() > 1E-9){
//   //cout << "Node " << name << " has base cost " << get_baseCost() << endl;
//     //}

//   if(iter==1){
//     return get_baseCost();
//   }
//   else{
//     //if(iter > 90){
//     //cout << "Node " << name << " has base cost " << get_baseCost() << ", history cost " << get_historyCost(iter);
//     //cout << " present sharing " << get_presentSharing(iter,pathfinder_pshare) << endl;
//     //}
//     return get_baseCost()*get_historyCost(iter)*get_presentSharing(iter,pathfinder_pshare, timing_driven);
//   }
// }

// double routingNode::returnTimingCost(int iter, double linkCriticality, bool pathfinder_pshare, double edgeDelay){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   //if(iter==1)
//   //  return (intrinsicDelay + edgeDelay);
//   //else
//   //cout << "Cost = " << (linkCriticality * (intrinsicDelay + edgeDelay)) + ((1 - linkCriticality) * returnCongestionCost(iter, pathfinder_pshare))<<endl;

//   //We can actually get negative timing cost if the link is super-critical (criticality larger than 1.0)
//   if((linkCriticality * (intrinsicDelay + edgeDelay)) + ((1 - linkCriticality) * returnCongestionCost(iter, pathfinder_pshare, true)) < 0){
//     ERROR("Returning negative timing cost!");
//   }
//   return ((linkCriticality * (intrinsicDelay + edgeDelay)) + ((1 - linkCriticality) * returnCongestionCost(iter, pathfinder_pshare, true)));
// }

// Whether this node's sharing has already been included in cost calculations 
void routingNode::set_counted(bool cn){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  counted=cn;
}

bool routingNode::get_counted(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return counted;
}

// Get the name of this routing node
string routingNode::get_name(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return name;
}

// Get this node's wavefront predecessor
routingNode* routingNode::get_predecessor(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return predecessor;
}

// Get type of routing node
e_routingNodeType routingNode::get_type(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return type;
}

// Get the resistance of wire routing node
double routingNode::get_R(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return R;
}

// Get the input cap of wire routing node
double routingNode::get_Cin(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return Cin;
}

// Get the output cap of wire routing node
double routingNode::get_Cout(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return Cout;
}

// Get next element from faninList
routingEdge* routingNode::getnext_faninList(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");

  if(*fanin_itr == faninList.end())
    return 0;
  else{
    routingEdge* ret_ptr = **fanin_itr;
    (*fanin_itr)++;
    return ret_ptr;
  }

}

// // Get next element from fanoutList
// routingEdge* routingNode::getnext_fanoutList(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");

//   if(*fanout_itr == fanoutList.end())
//     return 0;
//   else{
//     routingEdge* ret_ptr = **fanout_itr;
//     (*fanout_itr)++;
//     return ret_ptr;
//   }

// }

// Clear the list of terminals mapped to this routing node
// void routingNode::clear_terminalList(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   terminalList.clear();
// }

// Get base cost of this routing node
// double routingNode::get_baseCost(){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");

//   if(baseCost == 1.0){
//     cout << "Node " << name << " has base cost = 1.0!" << endl;
//   }
//   return baseCost;
// }

// // Get current history cost of this routing node
// double routingNode::get_historyCost(int iter){
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");
//   return historyCost;
// }

// // Get current present sharing cost of routing node
// double routingNode::get_presentSharing(int iter,bool pathfinder_pshare, bool timing_driven){
//   double pfac;
//   if(magicNum!=19111)
//     ERROR("trying to access a deleted node...");

//   /***** THIS WAS FPGA'05 presentSharing UPDATE MECHANISM *****/

// //   if(pathfinder_pshare)
// //     presentSharing=1.0 + doubmax(0.,((double)(1.0+occupancy-capacity)) * ((double)(iter)));
// //   else
// //     presentSharing=1.0 + doubmax(0.,(double)(1.0+occupancy-capacity));
  

//   if(timing_driven){
//     pfac = iter;
//   }
//   else{
//     pfac = pow(1.5,(double)iter);
//     //pfac = iter;
//   }
//   if(pathfinder_pshare)
//     presentSharing=1.0 + doubmax(0.,((double)(1.0+occupancy-capacity)) * (pfac));
//   else
//     presentSharing=1.0 + doubmax(0.,(double)(1.0+occupancy-capacity));

//   return presentSharing;
// }

// Get the current occupancy of this node
int routingNode::get_occupancy(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return occupancy;
}

// Get the capacity of this node
int routingNode::get_capacity(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return capacity;
}

// Get whether this node has been explored by a wavefront
bool routingNode::get_isExplored(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return isExplored;
}

// Get current path cost of this routing node
double routingNode::get_pathCost(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");
  return pathCost;
}

// Print details about this routing node.
// This function only prints architectural and netlist info.
void routingNode::print_info(){
  if(magicNum!=19111)
    ERROR("trying to access a deleted node...");

  cout<<endl<<endl<<"NODE: "<<name<<".";
  if(type==SOURCE)
    cout<<"  SOURCE NODE";
  else if(type==SINK)
    cout<<"  SINK NODE";
  else if(type==BUS_OR_WIRE)
    cout<<"  BUS_OR_WIRE";
  else if(type==INPUT_PIN)
    cout<<"  INPUT PIN";
  else if(type==OUTPUT_PIN)
    cout<<"  OUTPUT PIN";
  else if(type==DELAY)
    cout<<"  DELAY";
  else
    ERROR("Problem with routing tree!");
  

  cout<<"  ("<<col_low<<","<<row_low<<")"<<" to "<<"("<<col_high<<","<<row_high<<")";

//    cout<<endl<<"\tFANIN ROUTING EDGES ARE -->";
//    list<routingEdge*>::iterator fanin_itr = faninList.begin();
//    for(;fanin_itr!=faninList.end();fanin_itr++){
//      cout<<" ";
//      (*fanin_itr)->print_info();
//    }

  int fanout_size=fanoutList.size();
  cout<<endl<<"   "<<fanout_size<<" EDGES:";
  list<routingEdge*>::iterator fanout_itr = fanoutList.begin();
  for(;fanout_itr!=fanoutList.end();fanout_itr++){
    cout<<" ";
    (*fanout_itr)->print_info();
  }

  int fanout_type;
  fanout_itr=fanoutList.begin();
  cout<<endl<<"SWITCH TYPES:";
  for(;fanout_itr!=fanoutList.end();fanout_itr++){
    cout<<" ";
    fanout_type=(*fanout_itr)->get_type();
    cout<<fanout_type;
  }

  cout<<endl<<"OCC: "<<occupancy<<" CAPACITY: "<<capacity<<".";
  cout<<endl<<"R: "<<R<<" C: "<<C;

}

void routingNode::set_inPRTree(int latency){
  inPRTree.at(latency / NUMVECTORBITS) = inPRTree.at(latency / NUMVECTORBITS) | VECTORMASK[latency % NUMVECTORBITS];
}

bool routingNode::check_inPRTree(int latency){
  if(inPRTree.at(latency / NUMVECTORBITS) & VECTORMASK[latency % NUMVECTORBITS]){
    return true;
  }
  else{
    return false;
  }
}

bool routingNode::check_exploredAtLatency(int latency){
  int critIndex;

  for(critIndex = 0; critIndex < NUMASSUMEDCRIT; critIndex++){
    if(pIsExplored.at(critIndex).at(latency) > 0){
      return true;
    }
  }
  return false;
}
